unit hiCheckBoxEx;

interface

uses Windows,Kol,Share,Win;

{$I share.inc}

type
  THICheckBoxEx = class(THIWin)
   private
     ini:PIniFile;
     key:string;
     procedure _OnClick(Obj:PObj);
     procedure SetCaption(const Value:string);
     procedure SetChecked(Value:byte);
   public
    _event_onCheck:THI_Event;
    _event_onClick:THI_Event;

    //  
    _prop_SaveStatus:boolean;
    _prop_FileName:string;
    _prop_SectionName:string;
    _prop_KeyName:string;

    constructor Create(Parent:PControl);
    procedure Init; override;
    procedure _work_doCheck(var _Data:TData; Index:word);
    procedure _work_doCaption(var _Data:TData; Index:word);
    procedure _var_Checked(var _Data:TData; Index:word);
    property _prop_Checked:byte write SetChecked;
    property _prop_Caption:string write SetCaption;
  end;

implementation

constructor THICheckBoxEx.Create;
begin
   inherited Create(Parent);
   Control := NewCheckbox(Parent,'CheckBox');
   Control.OnClick := _OnClick;
   {$ifdef F_P}
   _prop_Ctl3D := 0;
   {$else}
   _prop_Ctl3D := 1;
   {$endif}
end;

procedure THICheckBoxEx.Init;
begin
   if _prop_SaveStatus then
    begin
     if _prop_FileName = '' then exit;
     if _prop_SectionName = '' then exit;
     if _prop_KeyName = '' then key := Control.Caption
      else key := _prop_KeyName;
     ini := OpenIniFile(GetStartDir + _prop_FileName);
     ini.Section := _prop_SectionName;
     ini.Mode := ifmRead;
     Control.Checked := Boolean(ini.ValueInteger(key,0));
    end;
   inherited;
end;

procedure THICheckBoxEx._work_doCheck;
begin
   Control.Checked := ReadBool(_Data);
   _hi_onEvent(_event_onCheck,byte(Control.Checked ));
end;

procedure THICheckBoxEx._work_doCaption;
begin
   Control.Caption := ToString(_Data);
end;

procedure THICheckBoxEx._var_Checked;
begin
   dtInteger(_Data,integer(Control.Checked));
end;

procedure THICheckBoxEx.SetCaption;
begin
   Control.Caption := Value;
end;

procedure THICheckBoxEx.SetChecked;
begin
   Control.Checked := Value = 0;
end;

procedure THICheckBoxEx._OnClick;
begin
   _hi_onEvent(_event_onCheck,byte(Control.Checked ));
   _hi_onEvent(_event_onClick,byte(Control.Checked ));
   // 
   if _prop_SaveStatus then
    begin
     if _prop_FileName = '' then exit;
     if _prop_SectionName = '' then exit;
     if _prop_KeyName = '' then key := Control.Caption
      else key := _prop_KeyName;
     ini := OpenIniFile(GetStartDir + _prop_FileName);
     ini.Section := _prop_SectionName;
     ini.Mode := ifmWrite;
     ini.ValueInteger(key,integer(Control.Checked));
    end;
end;

end.
