unit hiHashTableString;

interface

uses Kol,Share,Debug;

type
  ThiHashTableString = class(TDebug)
   private
    FList:PStrList;
    Arr:PArray; 

    procedure _Add(var Val:TData);
    procedure CreateHash;
   private
    FIndex:integer;
    FString:string;
   
   public
    _prop_Char:PChar;
    _prop_FileName:string;
    _prop_AddType:byte;
    _data_FileName:THI_Event;
    _data_str:THI_Event;
    _event_onChange:THI_Event;
    _event_onString:THI_Event;
    _event_onFalse:THI_Event;
    _data_Keystr:THI_Event;
    
     constructor Create;
    destructor Destroy; override;
    procedure _work_doKey(var _Data:TData; Index:word);
    procedure _work_doAdd0(var _Data:TData; Index:word);
    procedure _work_doAdd1(var _Data:TData; Index:word);    
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doReplace(var _Data:TData; Index:word);
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _var_Text(var _Data:TData; Index:word);
    procedure _var_String(var _Data:TData; Index:word);
    end;

implementation
  var
PosChSt,aTableSize:integer;  
aKey:ShortString;
 aCh: PChar;
HashTable : array of array of integer;

{   .   5    Pos(), ..
       }
function PosCh(aCh: PChar; const S: string; StartPos: integer = 1): integer;
var
  i: integer;
begin
  Result := 0;
  for i := StartPos to Length(S) do
    if (S[i] = aCh) then begin
      Result := i;
      exit;
    end;
end;
{   LeftString=RightString}
function RuleLeft(const Rule: string): string;
begin
PosChSt:= PosCh(aCh,Rule) ;
  Result := Copy(Rule,1,PosChSt-1);
end;

{   LeftString=RightString}
function RuleRight(const Rule: string): string;
begin
  Result := Copy(Rule,PosChSt+1,Length(Rule));
end;


// HashTableCount:integer;
 {  ,    m}
function FirstSimpleAfter(m: integer): integer;
var
  n, k: integer;
  simple: boolean;
begin
  n := m;
  if n mod 2 = 0 then Inc(n);
  while True do begin
    k := 3;
    simple := True;
    while k*k<n do begin
      if (n mod k = 0) then simple := False;
      Inc(k);
    end;
    if not simple then Inc(n,2)
                  else begin
                    Result := n;
                    exit;
                  end;
  end;
end;
 
function PJWHash(const aKey: string; aTableSize: integer): integer;
var
  G: longint;
i: integer;
  Hash: longint;
begin
  Hash := 0;
  for i := 1 to Length(akey) do begin
    Hash := (Hash shl 4)+ord(aKey[i]);
    G := Hash and longint($F0000000);
    if (G <> 0) then
      Hash := (Hash xor (G shr 24)) xor G;
  end;
  Result := Hash mod aTableSize;
end;

constructor ThiHashTableString.Create;
begin
   inherited Create;
   FList := NewStrList;
   FIndex := -1;
end;

destructor ThiHashTableString.Destroy;
begin
   FList.Free;
   if Arr <> nil then dispose(Arr);
   inherited Destroy;
end;


 procedure ThiHashTableString.CreateHash;
var   
ListLength,i,dubleHash: integer;  
begin
   if (_prop_Char = '') then exit;
   aCh:=_prop_Char;
//   aCh:='='; 
   ListLength:=FList.Count-1;   
   aTableSize:= FirstSimpleAfter(FList.Count);   
   SetLength(HashTable,2);
   SetLength(HashTable[0],aTableSize * 2);
   SetLength(HashTable[1],aTableSize * 2);
   dubleHash:=aTableSize;
      for i := 0 to (aTableSize * 2)-1 do
          begin HashTable[0,i]:=-1; HashTable[1,i]:=-1; end;
   for i := 0 to ListLength do
        begin
       FString := FList.Items[i];
       aKey := Parse(FString,aCh);
       FIndex:=PJWHash(aKey,aTableSize);
      if  HashTable[0,FIndex]=-1 then HashTable[0,FIndex]:= i 
             else 
         begin         
          While  HashTable[1,FIndex] > -1 do
           begin
           FIndex:=HashTable[1,FIndex];                      
            end;
          HashTable[1,FIndex]:=dubleHash;
                HashTable[0,dubleHash]:=i;
          inc(dubleHash); 
        end 
      end;        
  
end;


procedure ThiHashTableString._work_doKey;
var  
 Key:string;
ind, KIndex:integer;
begin
  aKey := ReadString(_Data,_data_Keystr);
  KIndex:=PJWHash(aKey,aTableSize); 
 ind:= HashTable[0,KIndex]; 
  Key:=RuleLeft(FList.Items[ind]);
  
 if 0=AnsiCompareStr(aKey,Key) then
  begin
       _hi_CreateEvent(_Data, @_event_onString,RuleRight(FList.Items[ind]));
       FIndex:=ind;
       FString:=FList.Items[ind];
 //    _hi_OnEvent(_event_onString,RuleRight(FList.Items[ind]));
    exit; 
  end    
 else 
   begin
   While  HashTable[1,KIndex] > -1 do
           begin
           KIndex:=HashTable[1,KIndex];
           ind:=HashTable[0,KIndex];
           Key:=RuleLeft(FList.Items[ind]);           
     if 0=AnsiCompareStr(aKey,Key) then
      begin
  _hi_CreateEvent(_Data, @_event_onString,RuleRight(FList.Items[ind]));
  FIndex:=ind;
  FString:=FList.Items[ind];    
//     _hi_OnEvent(_event_onString,RuleRight(FList.Items[ind])) ;
     exit;
       end 
  end; 
 // _hi_OnEvent(_event_onFalse,aKey);
 _hi_CreateEvent(_Data, @_event_onFalse);
 end 
       
end;

procedure ThiHashTableString._work_doAdd0;
begin
   FList.Add(ReadString(_Data,_data_str,''));
   CreateHash;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure ThiHashTableString._work_doAdd1;
begin
   FList.Insert(0,ReadString(_Data,_data_str,''));
   CreateHash;
   _hi_CreateEvent(_Data, @_event_onChange);
end; 

procedure ThiHashTableString._work_doDelete;
var   ind:integer;
begin
     if (FIndex < 0) or (FIndex > FList.Count - 1) then exit;
   FList.Delete(FIndex);
   CreateHash;
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure ThiHashTableString._work_doReplace;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if (FIndex < 0) or (FIndex > FList.Count - 1) then exit;
   FList.Delete(FIndex);
   FList.Insert(FIndex, ReadString(_Data, _data_str, ''));
    CreateHash;   
   _hi_CreateEvent(_Data, @_event_onChange);
end;

procedure ThiHashTableString._work_doLoad;
var   fn:string;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if FileExists(fn) then begin
      FList.LoadFromFile(fn);
 CreateHash;
 _hi_CreateEvent(_Data, @_event_onChange);     
   end;
end;

procedure ThiHashTableString._work_doSave;
var   fn:string;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   FList.SaveToFile(fn);
end;


procedure ThiHashTableString._var_Text;
begin
   dtString(_Data,FList.Text);
end;

procedure ThiHashTableString._var_String;
begin
  dtString(_Data,FString);
end;

procedure ThiHashTableString._Add;
begin
   FList.Add(ToString(val));
  end;
end.