unit hiShellBrowser;

interface

uses Kol,Windows,Share,Win,Debug,KOLBAPShellBrowser;

type
  THIShellBrowser = class(THIWin)
   private
   procedure _OnShellClickItem(Sender: PObj);
   procedure _OnChangeDir(Obj:PObj);
   procedure _OnDblClk( Ctl : PControl; var Mouse: TMouseEventData);
   procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); virtual;
   procedure _OnShellSelItem(Ctl: PControl; Txt: String);
  public
    _prop_DefaultDir:string;
    _prop_ShellFilter:string;
    _prop_ShowUpDir:boolean;
    _prop_AutoDblClicks:boolean;
    _prop_ShowOnlyFiles:boolean;
    _prop_Style:TListViewStyle;
    _prop_ShellSort:TSortDirRules;

    _prop_FileCollum:string;
    _prop_FileCollumWidth:integer;
    _prop_SizeCollum:string;
    _prop_SizeCollumWidth:integer;
    _prop_DateCollum:string;
    _prop_DateCollumWidth:integer;

    _event_onClick:THI_Event;
    _event_onDblClick:THI_Event;
    _event_onChangeDir:THI_Event;
    _event_onGetSelect:THI_Event;
    _event_onFileNotFound:THI_Event;

    procedure Init; override;
    procedure _work_doSetDir(var _Data:TData; Index:word);
    procedure _work_doSetfile(var _Data:TData; Index:word);  //
    procedure _work_doUpLevel(var _Data:TData; Index:word);
    procedure _work_doRootDir(var _Data:TData; Index:word);
    procedure _work_doShellUpdate(var _Data:TData; Index:word);
    procedure _work_doStyle(var _Data:TData; Index:word);
    procedure _work_doGetSelect(var _Data:TData; Index:word);
    procedure _work_doShellFilter(var _Data:TData; Index:word);
    procedure _work_doShellSort(var _Data:TData; Index:word);
    procedure _var_Select(var _Data:TData; Index:word);
  end;

implementation

var Current:string;

procedure THIShellBrowser._OnShellClickItem;
begin
 if PBAPShellB(Control).selfolder = '' then
 Current := PBAPShellB(Control).selfile  else
 Current := PBAPShellB(Control).selfolder;
  _hi_OnEvent(_event_onClick,Current);
end;

procedure THIShellBrowser._OnDblClk;
begin
 if PBAPShellB(Control).selfolder = '' then
 Current := PBAPShellB(Control).selfile else
 Current := PBAPShellB(Control).selfolder;
 _hi_OnEvent(_event_onDblClick,Current);
 if not _prop_AutoDblClicks then exit;
 if (PBAPShellB(Control).ShellPath = PBAPShellB(Control).selfolder) then
 PBAPShellB(Control).LevelUp else if (PBAPShellB(Control).selfile <> '') then
 PBAPShellB(Control).Execute(Control.CurIndex) else
 PBAPShellB(Control).ShellPath := PBAPShellB(Control).selfolder;
end;

procedure THIShellBrowser._OnShellSelItem;
begin
 _hi_OnEvent(_event_onGetSelect,Txt);
end;

procedure THIShellBrowser.Init;
begin
Control := NewBAPShellBrowser(FParent,_prop_Style,_prop_FileCollum,_prop_SizeCollum,_prop_DateCollum,
_prop_FileCollumWidth,_prop_SizeCollumWidth,_prop_DateCollumWidth);
With PBAPShellB(Control)^ do begin
 ShellPath := _prop_DefaultDir;
 ShellFilter := _prop_ShellFilter;
 ShellSort := _prop_ShellSort;
 ShowUpDir := _prop_ShowUpDir;
 ShowOnlyFiles :=_prop_ShowOnlyFiles;
 OnChangeDir := _OnChangeDir;
 OnShellSelItem := _OnShellSelItem;
end;
   inherited;
Control.OnClick := _OnShellClickItem;
Control.OnMouseDblClk := _OnDblClk;
end;

procedure THIShellBrowser._onMouseDown;
begin
   Ms := Mouse;
   with Mouse do
    _hi_OnEvent(_event_onMouseDown, integer(Ms.Button)-1);
 if PBAPShellB(Control).selfolder = '' then
 Current := PBAPShellB(Control).selfile else
 Current := PBAPShellB(Control).selfolder;
end;

procedure THIShellBrowser._work_doSetDir;
var s:string;
begin
s := ToString(_Data);
 if s <> '' then PBAPShellB(Control).ShellPath := s;
 SetFocus(Control.handle);
end;
procedure THIShellBrowser._work_doSetfile;
var s:string;
 p:Integer;
//D: PShellData;
begin
p := 0;
s := ToString(_Data);
if s <> '' then
 begin
 PBAPShellB(Control).ShellPath := ExtractFilePath(s);
   PBAPShellB(Control).LVCurItem := p;
while (p <> PBAPShellB(Control).count) and (s<>PBAPShellB(Control).selfile) do
begin
inc(p);
PBAPShellB(Control).LVCurItem := p;
 end; if p = PBAPShellB(Control).count then _hi_OnEvent(_event_onFileNotFound,'FILE NOT FOUND') else
   begin
 PBAPShellB(Control).LVMakeVisible(p + PBAPShellB(Control).LVPerPage div 2, FALSE);
 PBAPShellB(Control).LVMakeVisible(p, FALSE);
 SetFocus(Control.handle);
   end;
 end;   
end;      //ExtractFilePath(s)

procedure THIShellBrowser._work_doUpLevel;
begin
PBAPShellB(Control).LevelUp;
SetFocus(Control.handle);
end;

procedure THIShellBrowser._work_doRootDir;
begin
PBAPShellB(Control).RootDir;
end;

procedure THIShellBrowser._work_doShellUpdate;
begin
PBAPShellB(Control).ShellUpdate;
end;

procedure THIShellBrowser._work_doStyle;
var s:string;
begin
Control.LVStyle := TListViewStyle(ToInteger(_Data));
end;

procedure THIShellBrowser._work_doGetSelect;
begin
 PBAPShellB(Control).ShellSelect(false);
end;

procedure THIShellBrowser._work_doShellFilter;
begin
 PBAPShellB(Control).ShellFilter := ToString(_Data);
end;

procedure THIShellBrowser._work_doShellSort;
var s:string;
begin
PBAPShellB(Control).ShellSort := TSortDirRules(ToInteger(_Data));
end;

procedure THIShellBrowser._OnChangeDir;
begin
 Current := PBAPShellB(Control).ShellPath;
  _hi_OnEvent(_event_onChangeDir,PBAPShellB(Control).ShellPath);
end;

procedure THIShellBrowser._var_Select;
begin
 if PBAPShellB(Control).selfolder = '' then
 Current := PBAPShellB(Control).selfile else
 Current := PBAPShellB(Control).selfolder;
 _Data.Data_type := data_str;
 _Data.sdata := Current;
end;
end.
