unit hiUnRAR;

interface

uses Windows,Kol,Share,Debug,UnRAR;

type
	THIUnRAR = class(TDebug)
	private
		hArcData: THandle;
		RHCode, PFCode, StopFlag: Integer;
		HeaderData: RARHeaderDataEx;
		OpenArchiveData: RAROpenArchiveDataEx;
	public

		_event_onEvent:THI_Event;
		_event_onStop:THI_Event;
		_event_onError:THI_Event;

		_data_ArchiveFileName:THI_Event;
		_data_DistinationPath:THI_Event;

		procedure _work_Extract(var _Data:TData; Index:word);
		procedure _work_Test(var _Data:TData; Index:word);
		procedure _work_List(var _Data:TData; Index:word);
		procedure _work_Stop(var _Data:TData; Index:word);
		procedure _work_Version(var _Data:TData; Index:word);

		procedure _var_FileName(var _Data:TData; Index:word);
		procedure _var_Flags(var _Data:TData; Index:word);
		procedure _var_PackSize(var _Data:TData; Index:word);
		procedure _var_UnpSize(var _Data:TData; Index:word);
		procedure _var_HostOS(var _Data:TData; Index:word);
		procedure _var_FileCRC(var _Data:TData; Index:word);
		procedure _var_FileTime(var _Data:TData; Index:word);
		procedure _var_UnpVer(var _Data:TData; Index:word);
		procedure _var_FileAttr(var _Data:TData; Index:word);
	end;

implementation

procedure THIUnRAR._work_Extract;
begin
	OpenArchiveData.ArcName := PChar(ReadString(_Data,_data_ArchiveFileName,''));
	OpenArchiveData.OpenMode := RAR_OM_EXTRACT;
	hArcData := RAROpenArchiveEx(OpenArchiveData);

	if (OpenArchiveData.OpenResult <> 0) then begin _hi_OnEvent(_event_onError,OpenArchiveData.OpenResult); Exit; end;

	StopFlag := 0;
	repeat
		RHCode := RARReadHeaderEx(hArcData, HeaderData);
		if (RHCode <> 0) then begin _hi_OnEvent(_event_onError,RHCode); Break; end;

		PFCode := RARProcessFile(hArcData, RAR_EXTRACT, PChar(ReadString(_Data,_data_DistinationPath,'')), nil);
		if (PFCode <> 0) then begin _hi_OnEvent(_event_onError,PFCode); Break; end;
		if StopFlag = 1 then begin _hi_OnEvent(_event_onStop,1); Break; end;
	until False;

	if (RHCode = ERAR_BAD_DATA)
		then _hi_OnEvent(_event_onError,ERAR_BAD_ARCHIVE)	//	'File header broken'
		else _hi_OnEvent(_event_onStop,1);

	RARCloseArchive(hArcData);
end;

procedure THIUnRAR._work_Test;
begin
	OpenArchiveData.ArcName := PChar(ReadString(_Data,_data_ArchiveFileName,''));
	OpenArchiveData.OpenMode := RAR_OM_EXTRACT;
	hArcData := RAROpenArchiveEx(OpenArchiveData);

	if (OpenArchiveData.OpenResult <> 0) then begin _hi_OnEvent(_event_onError,OpenArchiveData.OpenResult); Exit; end;

	StopFlag := 0;
	repeat
		RHCode := RARReadHeaderEx(hArcData, HeaderData);
		if (RHCode <> 0) then begin _hi_OnEvent(_event_onError,RHCode); Break; end;

		PFCode := RARProcessFile(hArcData, RAR_TEST, nil, nil);
		if (PFCode <> 0) then begin _hi_OnEvent(_event_onError,PFCode); Break; end;
		if StopFlag = 1 then begin _hi_OnEvent(_event_onStop,1); Break; end;
	until False;

	if (RHCode = ERAR_BAD_DATA)
		then _hi_OnEvent(_event_onError,ERAR_BAD_ARCHIVE)	//	'File header broken'
		else _hi_OnEvent(_event_onStop,1);

	RARCloseArchive(hArcData);
end;

procedure THIUnRAR._work_List;
begin
	OpenArchiveData.ArcName := PChar(ReadString(_Data,_data_ArchiveFileName,''));
	OpenArchiveData.OpenMode := RAR_OM_LIST;
	hArcData := RAROpenArchiveEx(OpenArchiveData);

	if (OpenArchiveData.OpenResult <> 0) then begin _hi_OnEvent(_event_onError,OpenArchiveData.OpenResult); Exit; end;

	StopFlag := 0;
	repeat
		RHCode := RARReadHeaderEx(hArcData, HeaderData);
		if (RHCode <> 0) then begin _hi_OnEvent(_event_onError,RHCode); Break; end;

		PFCode := RARProcessFile(hArcData, RAR_SKIP, nil, nil);
		if (PFCode <> 0) then begin _hi_OnEvent(_event_onError,PFCode); Break; end;

		_hi_OnEvent(_event_onEvent,HeaderData.FileName);
		if StopFlag = 1 then begin _hi_OnEvent(_event_onStop,1); Break; end;
	until False;

	if (RHCode = ERAR_BAD_DATA)
		then _hi_OnEvent(_event_onError,ERAR_BAD_ARCHIVE)	//	'File header broken'
		else _hi_OnEvent(_event_onStop,1);

	RARCloseArchive(hArcData);
end;

procedure THIUnRAR._work_Stop;
begin
	StopFlag := 1;
end;

procedure THIUnRAR._work_Version;
begin
	_hi_OnEvent(_event_onEvent,RARGetDllVersion());
end;

procedure THIUnRAR._var_FileName;
begin
	_Data.data_type := data_str;
	_Data.sdata := HeaderData.FileName;
end;

procedure THIUnRAR._var_Flags;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.Flags;
end;

procedure THIUnRAR._var_PackSize;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.PackSize;
end;

procedure THIUnRAR._var_UnpSize;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.UnpSize;
end;

procedure THIUnRAR._var_HostOS;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.HostOS;
end;

procedure THIUnRAR._var_FileCRC;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.FileCRC;
end;

procedure THIUnRAR._var_FileTime;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.FileTime;
end;

procedure THIUnRAR._var_UnpVer;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.UnpVer;
end;

procedure THIUnRAR._var_FileAttr;
begin
	_Data.data_type := data_int;
	_Data.idata := HeaderData.FileAttr;
end;

end.
